$LOAD_PATH << './lib'
require './lib/em-zipper'

EM.run do
  EM.add_periodic_timer(1) { puts 'tick' } # tick tock


  # file zip to file
  #
  files = %w(sample1.txt sample2.txt).map do |file_name|
    File.join(File.expand_path("./examples/files"), file_name)
  end

  fbuff = File.new('file-non-blocking.zip', 'w')
  fzip  = EM::Zipper.new(files, fbuff)
  fzip.callback do |io|
    puts 'File zipped from files'
  end


  # http remotes to file
  #
  sites = %w(http://s3.amazonaws.com/ping-em-assets/sample1.txt http://s3.amazonaws.com/ping-em-assets/sample2.txt)
  rbuff = File.new('remotes-file-non-blocking.zip', 'w')
  rzip  = EM::Zipper.new(sites, rbuff)
  rzip.callback do |io|
    puts 'File zipped from remotes'
  end


  fzip.zip!
  rzip.zip!
end

