$LOAD_PATH << './lib'
require './lib/em-zipper'

def write_io_to_file(io, file_name)
  q = EM::Queue.new
  file = File.new(file_name, 'w')

  wf = proc do |chunk|
    file.write chunk
    if q.empty?
      file.close
    else
      EM.next_tick { q.pop(&wf) }
    end
  end

  io.rewind
  while buffer = io.read(16348)
    q.push buffer
  end
  q.pop(&wf)
end


EM.run do
  EM.add_periodic_timer(1) { puts 'tick' } # tick tock

  # file to IO to file
  #
  files = %w(sample1.txt sample2.txt).map do |file_name|
    File.join(File.expand_path("./examples/files"), file_name)
  end

  fzip = EM::Zipper.new files, StringIO.new
  fzip.callback do |io|
    write_io_to_file(io, 'io-file-non-blocking.zip')
    puts 'IO zipped from files'
  end


  # remote to IO to file
  #
  sites = %w(http://s3.amazonaws.com/ping-em-assets/sample1.txt http://s3.amazonaws.com/ping-em-assets/sample2.txt)
  rzip  = EM::Zipper.new sites, StringIO.new
  rzip.callback do |io|
    write_io_to_file(io, 'io-remote-non-blocking.zip')
    puts 'IO zipped from remotes'
  end


  fzip.zip! 
  rzip.zip! 
end

